#ifndef __MYEVENT_H__
#define __MYEVENT_H__

#define MAX_EVENT 32

typedef struct {
	int value;
	void *userdata;
} myevent;

typedef struct {
	int head;
	int tail;
	myevent event[ MAX_EVENT ];
} myevent_q;

void add_event(int event, void *userdata);
int get_event(myevent *event);
void init_event_handler(void);
void close_event_handler(void);
#endif
