#ifndef __MYTIMER_H__
#define __MYTIMER_H__

#define MAX_TIMER 10

typedef struct
{
	int id;
	int repeat;
	double last_time;
	int interval;
	void *user_data;
	void (*callback)(void *priv);
} mytimer;

int set_timer(int interval, void (*callback)(void *priv), void *user_data, int repeat);
int reset_timer(int id);
#endif
